<!DOCTYPE html>
<html lang="en">
	<head>
		<title>CA.JS - V0.2.0</title>
		<meta charset="UTF-8">
		<link href="resources/style.css" rel="stylesheet" />
		<script language="javascript" src="resources/jc_page_events.js"></script>
		<script language="javascript" src="resources/jc_ca.js"></script>
		<script language="javascript">
		var vis = null;
		
		_JC_INST_.CAExtra = function(_mode)
		{
			var title = "";
			var body  = "";
			var url   = "";
			switch(_mode.toUpperCase())
			{
				case "WIREWORLD":
					title= "Wireworld";
					body= "Wireworld simulates electrons moving over wire. It uses an electron head and tail to encode direction and is Turing-complete. ";
					url  = "https://en.wikipedia.org/wiki/Wireworld";
				break;
				case "ANT":
					title= "Langton's ant";
					body= "Langton's ant uses 9 states to represent an ant that moves around the grid manipulating the cells it lands on. ";
					body+="For the first few 100 steps it produces simple, often symmetrical patterns. It then enters a chaotic phase for around 10,000 steps. ";
					body+="Finally order emerges with the ant creating a regular pattern that repeats every 104 steps.";				
					url  = "https://en.wikipedia.org/wiki/Langton%27s_ant";
				break;
				case "1D":
					title= "Elementary cellular automaton";
					body= "Elementary cellular automation is a one-dimensional cellular automation where each new generation is shown on the next line. There are 256 different rule configurations ";
					body+="for generating the next generation. The Wolfram code is used to assign each rule to a unique number between 0 and 256.";
					url  = "https://en.wikipedia.org/wiki/Elementary_cellular_automaton";
				break;
				case "CGOL":
				default:
					title= "Conway's Game of Life";
					body= "Conways Game of life is based on four simple rules. <ol><li>Any cell with fewer than two neighbors dies, as if by loneliness.</li>";
					body+="<li>Any cell with two of three neighbors lives on happily.</li>";
					body+="<li>Any cell with more than three neighbors dies, as if by overpopulation.</li>";
					body+="<li>Any dead cell with three neighbors is resurrected.</li></ol>";
					url  = "https://en.wikipedia.org/wiki/Conway%27s_Game_of_Life";
				break;
			}
			
			document.getElementById("blurbTitle").innerHTML = title;
			document.getElementById("blurbBody").innerHTML  = body;
			document.getElementById("blurbLink").setAttribute("href",url);
		};
		
		_JC_INST_.ToggleElementary = function(_mode)
		{
			var controls = document.getElementById("elementaryControls");
			if(_mode.toUpperCase() === "1D")
			{
				controls.setAttribute("style","display:block;");
			}
			else
			{
				controls.setAttribute("style","display:none;");
			}
		};

		_JC_INST_.PageEvents.RegisterEvent("onload",function()
		{
			_JC_INST_.CA = new JC_CA(document.getElementById("canvas"),100,80);
						
			//wire up commands
			document.getElementById("cmdStart").onclick = function()
			{
				_JC_INST_.CA.Start();
				return false;
			};
			
			document.getElementById("cmdStop").onclick = function()
			{
				_JC_INST_.CA.Stop();
				return false;
			};
			
			document.getElementById("cmdClear").onclick = function()
			{
				_JC_INST_.CA.Clear();
				return false;
			};
			
			document.getElementById("cmdReset").onclick = function()
			{
				_JC_INST_.CA.Reset();
				return false;
			};
			
			document.getElementById("cmdExample").onclick = function()
			{
				_JC_INST_.CA.AddExample();
				return false;
			};
			
			//wire up inputs
			document.getElementById("inputRule").onchange = function()
			{
				_JC_INST_.CA.SetRule(this.value);
				return false;
			};
			
			document.getElementById("inputRule").onclick = document.getElementById("inputRule").onchange;
			document.getElementById("inputRule").setAttribute("value",_JC_INST_.CA.GetRule());
			
			document.getElementById("inputCAType").onchange = function()
			{
				_JC_INST_.CA.SetMode(this.value);
				_JC_INST_.CAExtra(this.value);
				_JC_INST_.ToggleElementary(this.value);
				return false;
			};	
			document.getElementById("inputCAType").onchange(); //force intial selection to update GUI	
		});
		
		</script>
	</head>
	<body>
		<header class="light padded">
			<h1>CA.JS - V0.2.0</h1>
			<h2>A JavaScript Cellular automation library</h2>
			<h4>By Jon Keatley</h4>
			<p>This Cellular automation library provides the ability to edit and run four different types of cellular automation. It's only requirement is a HTML 5 canvas tag.</p>
			<nav>
				<a href="https://gitlab.com/Jon.Keatley.Folio/ca.js" target="blank">View Project</a>
				<a href="http://www.jon-keatley.com" target="blank">About Creator</a>
			</nav>
			
		</header>
		<article>
			<section class="dark">
			<h3>Controls</h3>
			<p>
			<a href="#" id="cmdStart"  >Start</a>
			<a href="#" id="cmdStop"   >Stop</a>
			<a href="#" id="cmdReset"  >Reset</a>
			<a href="#" id="cmdClear"  >Clear</a>
			<a href="#" id="cmdExample">Example</a>
			</p>
			<p>
				<label for="catype">CA Type</label><select name="catype" id="inputCAType">
					<option value="CGOL">Conway's Game of life</option>
					<option value="WIREWORLD">Wireworld</option>
					<option value="1D">Elementary</option>
					<option value="ANT">Langton's Ant</option>
				</select>
			</p>
			<p id="elementaryControls">
				<label for="rule">Elementary Rule</label><input name="rule" id="inputRule" type="number" min="0" max="255" value="128" />
			</p>
			</section>
			<section id="canvasContainer">
					<canvas width="800" height="600" id="canvas">
					Canvas not supported!
					</canvas>
			
					<aside class="light">
						<h3>Infomation</h3>
						<h4 id="blurbTitle"></h4>
						<p id="blurbBody"></p>
						<a href="#" id="blurbLink" target="blank">Click here to read more</a>
					</aside>
			</section>

		</article>
	</body>
</html>
			
